c quality check for the whaling ship data
c check: 1. |sst-tair| > 5.0 C;  2. SST < -5.0; 3. three decimals
c        4. |lat| > 90, |long| > 180, 5. beaufort > 12, direction > 360
c        6. month > 12, day > 31, year > 85  or year < 40

	parameter (fmiss=-999.,mon=13,nship=127)
	CHARACTER*60 fl1,fl2,fl3,fn(nship),buf,wind*8,bft*8
	character buffer*70,chr1,blank
	dimension whl(180,90,mon),ipp(180,90,mon)
	data bft/'Beaufort'/
	data blank/' '/

	open(3,file='whlchk.dat',status='unknow')

c read the whl file names
	open(1,file='whlania_ship.dat',status='old',readonly)
	
	do i=1,nship
	   read(1,101)fn(i)
c	   print *,i,'  ',fn(i)
 101	   format(54x,a)
	enddo
	
	close(1)

c read whl data
	ip=0

 	do k=1,nship

	   print *,k,'  ',fn(k)

	   fl1=fn(k)

	   write(3,301)k,fn(k)
 301	   format(i4,' possible error for ship - ',a15)

	   open(1,file=fl1,status='old',readonly)

c read one yearJWS data
	   read(1,'(a)')buf
c	   print *,buf
	   nt1=index(buf,'(')+1
c	   nt2=index(buf,')')-1
	   nt2=nt1+7
	   wind=buf(nt1:nt2)
	   if(wind.ne.bft) then
	      print *,'Warning: wind is not in Beaufort scale'
	      write(3,*)'Warning: wind is not in Beaufort scale'
	   endif
   
 1600	   read(1,'(a)',end=2000)buffer
c	   print *,buffer
c check empty buffer
	   ip1=0
	   do i=1,10
	      chr1=buffer(i:i)
	      if(chr1.eq.blank) then
		 ip1=ip1+1
	      endif
	   enddo
	   if(ip1.eq.10) goto 2000   ! empty buffer
	   
	   read(buffer,*)idate,imon,iyear,flat,flong,ibft,
	1	cdir,tair,sst

c	   if(idate.lt.1 .or.idate.gt.31) write(3,302)buffer
c	   if(imon.lt.1 .or.imon.gt.12) write(3,303)buffer
c	   if(iyear.lt.40 .or.iyear.gt.85) write(3,304)buffer

c	   if(flat.lt.-90 .or. flat.gt.90) write(3,305)buffer
c	   if(flong.lt.-180 .or.flong.gt.180) write(3,306)buffer

	   if(wind.eq.bft) then
c	      if(ibft.lt.0 .or.ibft.gt.12) write(3,307)buffer
	   else
c	      if(ibft.lt.0 .or.ibft.gt.40) write(3,307)buffer
	   endif
   
	   if(cdir.ne.999) then
c	      if(cdir.lt.0 .or.cdir.gt.360) write(3,308)buffer   
	   endif   

	   if(sst.ne.fmiss .and. tair.ne.fmiss) then
	      dd=abs(sst-tair)
	      sst1=nint(sst*10)-sst*10
	      tair1=nint(tair*10)-tair*10
	      if(dd.gt.5) write(3,309)buffer   
c	      if(sst.lt.-5) write(3,310)buffer   
c	      if(sst1.ne.0) write(3,311)buffer   
c	      if(tair1.ne.0) write(3,312)buffer
	   endif   

 302	   format('day err: ',a)
 303	   format('mon err: ',a)
 304	   format('yr  err: ',a)
 305	   format('lat err: ',a)
 306	   format('lng err: ',a)
 307	   format('bft err: ',a)
 308	   format('dir err: ',a)
 309	   format('dif err: ',a)
 310	   format('sst err: ',a)
 311	   format('dcs err: ',a)
 312	   format('dca err: ',a)

	   goto 1600

 2000	   close(1)

	enddo
 
	stop
	end

